﻿using System.Collections.Generic;
using System.Data.Services;
using System.ServiceModel.Web;
using Northwind.Data;
using System.Linq;


namespace DataEnd2End
{
    public class NorthwindService : DataService<NorthwindEntities>
    {
        public static void InitializeService(IDataServiceConfiguration config)
        {
            config.SetEntitySetAccessRule("Customers", EntitySetRights.All);
            config.SetEntitySetAccessRule("Orders", EntitySetRights.All);
            config.SetServiceOperationAccessRule("CustomersInLondon", ServiceOperationRights.All);
        }

        protected override void HandleException(HandleExceptionArgs args)
        {
            string message = "Message: " + args.Exception.Message;
            if (args.Exception.InnerException != null)
            {
                message += " InnerMessage: " + args.Exception.InnerException.Message;
            }
            args.Exception = new DataServiceException(400, "", message, "en-US", args.Exception);
        }

        [WebGet]
        public IList<Customers> CustomersInLondon()
        {
            var ctx = new NorthwindEntities();
            return (from c in ctx.Customers
                   where c.City == "London"
                   select c).ToList();
        }  

    }
}
