<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
<%@ Import Namespace="MyExtensions"%>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Run
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">

    <script type="text/javascript">
        var dataContext;
        var queryObject, queryObject1;   

        
        Sys.require([Sys.components.dataView, Sys.components.adoNetDataContext]);

        Sys.onReady(function() {
            dataContext = Sys.create.adoNetDataContext(
               {
                   serviceUri: "/NorthwindService.svc",
                   mergeOption: Sys.Data.MergeOption.appendOnly
               });
            dataContext.initialize();

            queryObject = new Sys.Data.AdoNetQueryBuilder("Customers");
            queryObject.set_orderby("ContactName");            //$orderby
            queryObject.set_filter("City eq " + "'London'");   // $filter
            queryObject.set_expand("Orders");                  //$expand

            queryObject1 = new Sys.Data.AdoNetQueryBuilder("Customers");
            queryObject1.set_filter("startswith(CompanyName, 'A')"); 
        });
    </script> 

    <script type="text/javascript">
        function doLoad() {
            var queryObject = new Sys.Data.AdoNetQueryBuilder("Customers");
            var id = Sys.get("#CustomerID").value;
            queryObject.set_filter("CustomerID eq '" + id + "'");
            var dv = Sys.get("$Editor");
            var command = queryObject.toString();
            dv.set_fetchOperation(command);
            dv.fetchData();
        }
    </script>     
    
    <script type="text/javascript">
        function doCommit() {
            var pendingChanges = dataContext.get_hasChanges();
            if (pendingChanges !== true) {
                alert("No pending changes to save.");
                return;
            }

            var changes = dataContext.get_changes();
            var buffer = "";
            for (var i = 0; i < changes.length; i++) {
                ch = changes[i];
                buffer += makeReadable(ch.action) + " --> " + ch.item["CustomerID"];
                buffer += "\n\tNew address: " + ch.item["Address"];
                buffer += "\n";
            }
            if (confirm(buffer))
                dataContext.saveChanges();
        }

        function makeReadable(action) {
            if (action === 0)
                return "Insert";     
            if (action === 1)
                return "Update";
            if (action === 2)
                return "Delete";
        }
    </script>    
    
    <h2>Demo in action</h2>

    <input type="button" value="Commit all changes" onclick="doCommit()" />
    
    <hr />
    
    <div id="Demo1" style="display:none;">
    <table>
        <tr class="tableHeader">
            <td>ID</td>
            <td>Name</td>
            <td>Contact</td>
            <td># Orders</td>
        </tr>
        <tbody sys:attach="dataview" 
               class="sys-template"
               dataview:dataprovider="{{ dataContext }}"
               dataview:fetchoperation="{{ queryObject.toString() }}"
               dataview:autofetch="true">
             <tr>
                 <td>{{ CustomerID }}</td>
                 <td>{{ CompanyName }}</td>
                 <td>{{ ContactName }}</td>
                 <td>{{ Orders.length }}</td>                 
             </tr>
         </tbody>
    </table>
    </div>
     
    <div id="Demo2" style="display:none;">
        <table>
            <tr class="tableHeader"><td>Customer ID</td></tr>
            <tr><td>
                <%= Html.TextBox("CustomerID", "ALFKI") %>
                <input type="button" value="Load" onclick="doLoad()" />
            </td></tr>
        </table>
        
        <br /><br />
        
        <table sys:attach="dataview" id="Editor"
               class="sys-template"
               dataview:dataprovider="{{ dataContext }}"
               dataview:autofetch="false">
            <tr>
                <td class="caption">ID</td>
                <td>{{ CustomerID }}</td>
            </tr>
            <tr>
                <td class="caption">Company</td>
                <td>{{ CompanyName }}</td>
            </tr>    
            <tr>            
                <td class="caption">Address</td>
                <td><%= Html.SysTextBox("Address", "{binding Address}") %></td>
            </tr>    
            <tr>       
                <td class="caption">City</td>         
                <td>{{ City }}</td>
            </tr>  
            <tr>
                <td align="right" colspan="2">
                    Changes stored automatically. Click to commit at any time.
                    <input type="button" value="Save" disabled="disabled" onclick="doSave()" />
                </td>
            </tr>          
        </table>
    </div>
    
    <div id="Demo3">
        <ul id="masterView"
                sys:attach="dataview"
                class="sys-template"
                dataview:dataprovider="{{ dataContext }}"
                dataview:fetchoperation="{{ queryObject1.toString() }}"
                dataview:autofetch="true">
              <li> <span sys:command="select">{ binding CompanyName }</span></li>
        </ul>
        
        <div id="detailsView">
            <table sys:attach="dataview" 
                   class="sys-template"
                   dataview:data="{binding selectedData, source=$masterView}">
                <tr>
                    <td class="caption">ID</td>
                    <td>{{ CustomerID }}</td>
                </tr>
                <tr>
                    <td class="caption">Company</td>
                    <td>{{ CompanyName }}</td>
                </tr>    
                <tr>            
                    <td class="caption">Address</td>
                    <td><%= Html.SysTextBox("Address", "{binding Address}") %></td>
                </tr>    
                <tr>       
                    <td class="caption">City</td>         
                    <td>{{ City }}</td>
                </tr>  
                <tr>
                    <td align="right" colspan="2">
                        Changes stored automatically. Click to commit at any time.
                        <input type="button" value="Save" disabled="disabled" onclick="doSave()" />
                    </td>
                </tr>          
            </table>
        </div>
    </div>
    
</asp:Content>
